org 00h 




CROP_SELECT equ 39h  
mov sp,#40h
main: 
 
;Main Code 
  
MOV TMOD, #21h 		;Timer 0 Mode 1, 16 bit timer (for generating 5 
			;second delay for LCD) 
			;timer 1 mode 2,8 bit auto reload for serial

mov TH1,#-3

mov SCON,#50h

setb tr1

 ;LCD initialisation 
MOV A, #38H    	 ;init. LCD 2 lines,5x7 matrix (CHANGE THIS!!!) 
ACALL comnwrt       	;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #0EH        ;display on, cursor on 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01h        ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #06H       ;shift cursor right 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 


lcd1:   			 ;Displaying initialisation message 
MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV DPTR, #init1    ;address of line 1 of initialisation message 
repeat1: 
CLR A 
MOVC A, @A+DPTR    ;moving the data to accumulator 
JZ line_2 
ACALL datawrt    ;call data display routine 
ACALL lcddelay    ;give LCD some time 
INC DPTR      ;increment address 
SJMP repeat1 
 
line_2: 
MOV A, #0C0h       ;cursor at line 2, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV DPTR, #init2    ;address of line 2 of initialisation message 
repeat2: 
CLR A 
MOVC A, @A+DPTR    ;moving the data to accumulator 
JZ crop 
LCALL datawrt    ;call data display routine 
LCALL lcddelay    ;give LCD some time 
INC DPTR      ;increment address 
SJMP repeat2    ;jump to label repeat2





;crop selection
crop:
LCALL delay_3s
MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01H      	 ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
	MOV DPTR, #crop1    ;address of line 1 of initialisation message 
repea1: 
	CLR A 
	MOVC A, @A+DPTR    ;moving the data to accumulator 
	JZ line_nxt 
	ACALL datawrt    ;call data display routine 
	ACALL lcddelay    ;give LCD some time 
	INC DPTR      ;increment address 
	SJMP repea1 
 
line_nxt: 
	MOV A, #0C0h       ;cursor at line 2, position 0 
	ACALL comnwrt       ;call command subroutine 
	ACALL lcddelay      ;give LCD some time 
	MOV DPTR, #crop2    ;address of line 2 of initialisation message 
repea2: 
	CLR A 
	MOVC A, @A+DPTR    ;moving the data to accumulator 
	JZ backc 
	LCALL datawrt    ;call data display routine 
	LCALL lcddelay    ;give LCD some time 
	INC DPTR      ;increment address 
	SJMP repea2    ;jump to label repeat2


backc:
LCALL delay_3s

MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01H      	 ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time

MOV DPTR, #bep    ;address of line 1 of initialisation message 
repea12: 
	CLR A 
	MOVC A, @A+DPTR    ;moving the data to accumulator 
	JZ bep 
	ACALL datawrt    ;call data display routine 
	ACALL lcddelay    ;give LCD some time 
	INC DPTR      ;increment address 
	SJMP repea12
bep:

	MOV R6, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
	back1: 
	MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
	MOV TH0, #4Bh 
	SETB TR0      ;Start timer 0 
	JNB TF0, $      ;Check for end of count 
	CLR TR0      ;Stop timer 
	CLR TF0      ;Clear timer 0 flag 
	LCALL selectr
	DJNZ R6, back1


;dlt

MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01H      	 ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time

MOV DPTR, #dlt    ;address of line 1 of initialisation message 
repea13: 
	CLR A 
	MOVC A, @A+DPTR    ;moving the data to accumulator 
	JZ kharchk 
	ACALL datawrt    ;call data display routine 
	ACALL lcddelay    ;give LCD some time 
	INC DPTR      ;increment address 
	SJMP repea13
kharchk:

	MOV R6, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
	back2: 
	MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
	MOV TH0, #4Bh 
	SETB TR0      ;Start timer 0 
	JNB TF0, $      ;Check for end of count 
	CLR TR0      ;Stop timer 
	CLR TF0      ;Clear timer 0 flag 
	LCALL selectk
	DJNZ R6, back2
	
sjmp backc	

kfinish:
MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01H      	 ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time
mov a,#'R'
acall datawrt
acall lcddelay
setb P2.0
sjmp $

rfinish:
MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01H      	 ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time
mov a,#'R'
acall datawrt
acall lcddelay
setb p2.1

sjmp $


lcddelay:  		;Delay subroutine  
	MOV R0, #90 
here1: 	MOV R1, #255 
here: 	DJNZ R1, here 
	DJNZ R0, here1 
	RET 

delay:  		;Delay subroutine  
	MOV R3, #250 
here2: 	MOV R4, #255 
here3: 	DJNZ R4, here3 
	DJNZ R3, here2 
	RET 

delay_5s:      ;5 second delay routine 
MOV R7, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
sec_5: 
MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
MOV TH0, #4Bh 
SETB TR0      ;Start timer 0 
JNB TF0, $      ;Check for end of count 
CLR TR0      ;Stop timer 
CLR TF0      ;Clear timer 0 flag 
DJNZ R7, sec_5    ;Repeat till R7=0 
RET

delay_3s:
MOV R7,#100
sec_2:
MOV TL0,#02h
MOV TH0,#0B8h
SETB TR0
JNB TF0,$
CLR TR0
CLR TF0
DJNZ R7,sec_2
RET

comnwrt:               		
lcall ready		; Write when display not busy
	mov p0,a		; Command character in P1
	clr p2.5		; Command resister chosen
	clr p2.4		; Write enabled
	setb p2.7		; Strobe character to display
	clr p2.7
	ret 

ready:
	clr p2.7		; Display disabled
	mov p0,#0ffh		; Configure P1 for input
	clr p2.5		; Select command register
	setb p2.4		; Read enabled


wait:
	clr p2.7		; Strobe display
	setb p2.7		; Read busy status of display
	jb p0.7,wait		; Wait for not busy (BF = 0)
	clr p2.7		; End display strobe
	ret 

datawrt:			;write data to LCD 
	lcall ready		; Write when display ready
	mov P0,a		; Data character in P1
	setb p2.5		; Data resister chosen
	clr p2.4		; write enabled
	setb p2.7		; Strobe character to display
	clr P2.7
	ret

selectr:
		setb p2.6
		JNB P2.6,yepr
		RET
		yepr:
		ajmp rfinish
selectk:
		setb p2.6
		JNB P2.6,yepk
		RET
		yepk:
		ajmp kfinish


org 600h 
 
init1: DB "WELCOME TO", 0 
init2: DB "    GREENHOUSE", 0  ; System initialisation message 

crop1: DB "PLEASE SELECT",0
crop2: DB "    YOUR CROP" ,0
bep: DB "     BEP",0
dlt: DB "     DLT",0

END