org 00h

RELAY1 EQU P2.0
RELAY2 EQU P2.1
RELAY3 EQU P2.2
RELAY4 EQU P2.3

clr RELAY1
clr RELAY2
clr RELAY3
clr RELAY4
MOV TMOD, #01h 		;Timer 0 Mode 1, 16 bit timer (for generating 5 
			;second delay for LCD)

back:

lcall delay_5s
setb RELAY1
lcall delay_5s
clr RELAY1


lcall delay_5s
setb RELAY2
lcall delay_5s
clr RELAY2

lcall delay_5s
setb RELAY3
lcall delay_5s
clr RELAY3

lcall delay_5s
setb RELAY4
lcall delay_5s
clr RELAY4

ljmp back
delay_5s:      ;5 second delay routine 
MOV R7, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
sec_5: 
MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
MOV TH0, #4Bh 
SETB TR0      ;Start timer 0 
JNB TF0, $      ;Check for end of count 
CLR TR0      ;Stop timer 
CLR TF0      ;Clear timer 0 flag 
DJNZ R7, sec_5    ;Repeat till R7=0 
RET

end