		org 0000h
		mov sp,#40h
		
		lcall delay_20ms
	
		mov a,#38h
		lcall command
		lcall DELAY
	
		mov a,#0ch	 ; Screen on and cursor off, no blink		
		lcall command
		lcall DELAY
	
	        mov a,#06h	 ; shift cursor right
		lcall command
		lcall DELAY
	
		mov a,#01h	 ; Clear screen and home cursor
		lcall command
		lcall DELAY
	
		mov a,#'S'       ;Write "SINE WAVE"        
		lcall display
		lcall DELAY
	
		mov a,#'I'
		lcall display
		lcall DELAY

		mov a,#'N'
		lcall display
		lcall DELAY

		mov a,#'E'
		lcall display
		lcall DELAY

		mov a,#' '
		lcall display
		lcall DELAY

		mov a,#'W'
		lcall display
		lcall DELAY

		mov a,#'A'
		lcall display
		lcall DELAY

		mov a,#'V'
		lcall display
		lcall DELAY

		mov a,#'E'
		lcall display
		lcall DELAY

		sjmp $

delay_20ms:	mov r1,#40
        A1:	mov r0,#250
		djnz r0,$
		djnz r1,A1
		   ret

DELAY:   MOV     R0,#90   	;50 or higher for fast CPUs
HERE2:   MOV     R1,#255   	;R1=255
HERE1:   DJNZ    R1,HERE1   	;stay until R1 becomes 0
         DJNZ    R0,HERE2
         RET

command:
	lcall ready		; Write when display not busy
	mov p0,a		; Command character in P1
	clr p2.5		; Command resister chosen
	clr p2.4		; Write enabled
	setb p2.7		; Strobe character to display
	clr p2.7
	ret
ready:
	clr p2.7		; Display disabled
	mov p0,#0ffh		; Configure P1 for input
	clr p2.5		; Select command register
	setb p2.4		; Read enabled


wait:
	clr p2.7		; Strobe display
	setb p2.7		; Read busy status of display
	jb p0.7,wait		; Wait for not busy (BF = 0)
	clr p2.7		; End display strobe
	ret 
display:
	lcall ready		; Write when display ready
	mov P0,a		; Data character in P1
	setb p2.5		; Data resister chosen
	clr p2.4		; write enabled
	setb p2.7		; Strobe character to display
	clr P2.7
	ret
end
